# coding=utf-8
# *** WARNING: this file was generated by pulumigen. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['DNSPreferencesConfigArgs', 'DNSPreferencesConfig']

@pulumi.input_type
class DNSPreferencesConfigArgs:
    def __init__(__self__, *,
                 magic_dns: pulumi.Input[bool],
                 tailnet: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a DNSPreferencesConfig resource.
        :param pulumi.Input[str] tailnet: For paid plans, your domain is your tailnet. For solo plans, the tailnet is the email you signed up with. So `alice@gmail.com` has the tailnet `alice@gmail.com` since `@gmail.com` is a shared email host. Alternatively, you can specify the value "-" to refer to the default tailnet of the authenticated user making the API call.
        """
        pulumi.set(__self__, "magic_dns", magic_dns)
        if tailnet is not None:
            pulumi.set(__self__, "tailnet", tailnet)

    @property
    @pulumi.getter(name="magicDNS")
    def magic_dns(self) -> pulumi.Input[bool]:
        return pulumi.get(self, "magic_dns")

    @magic_dns.setter
    def magic_dns(self, value: pulumi.Input[bool]):
        pulumi.set(self, "magic_dns", value)

    @property
    @pulumi.getter
    def tailnet(self) -> Optional[pulumi.Input[str]]:
        """
        For paid plans, your domain is your tailnet. For solo plans, the tailnet is the email you signed up with. So `alice@gmail.com` has the tailnet `alice@gmail.com` since `@gmail.com` is a shared email host. Alternatively, you can specify the value "-" to refer to the default tailnet of the authenticated user making the API call.
        """
        return pulumi.get(self, "tailnet")

    @tailnet.setter
    def tailnet(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "tailnet", value)


class DNSPreferencesConfig(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 magic_dns: Optional[pulumi.Input[bool]] = None,
                 tailnet: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a DNSPreferencesConfig resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] tailnet: For paid plans, your domain is your tailnet. For solo plans, the tailnet is the email you signed up with. So `alice@gmail.com` has the tailnet `alice@gmail.com` since `@gmail.com` is a shared email host. Alternatively, you can specify the value "-" to refer to the default tailnet of the authenticated user making the API call.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DNSPreferencesConfigArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a DNSPreferencesConfig resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param DNSPreferencesConfigArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DNSPreferencesConfigArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 magic_dns: Optional[pulumi.Input[bool]] = None,
                 tailnet: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DNSPreferencesConfigArgs.__new__(DNSPreferencesConfigArgs)

            if magic_dns is None and not opts.urn:
                raise TypeError("Missing required property 'magic_dns'")
            __props__.__dict__["magic_dns"] = magic_dns
            __props__.__dict__["tailnet"] = tailnet
        super(DNSPreferencesConfig, __self__).__init__(
            'tailscale-native:tailnet:DNSPreferencesConfig',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'DNSPreferencesConfig':
        """
        Get an existing DNSPreferencesConfig resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = DNSPreferencesConfigArgs.__new__(DNSPreferencesConfigArgs)

        __props__.__dict__["magic_dns"] = None
        return DNSPreferencesConfig(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="magicDNS")
    def magic_dns(self) -> pulumi.Output[bool]:
        return pulumi.get(self, "magic_dns")

